module ResourcePlanner
  class EventUnitSubscription < ApplicationRecord

    belongs_to :event_unit, :class_name => '::ResourcePlanner::EventUnit', :inverse_of => :subscriptions
    belongs_to :resource, :polymorphic => true

    #--------------------------------------------------------------------------

    #attr_accessible :name
    #attr_accessible :event, :event_id
    #attr_accessible :resource, :resource_id, :resource_type

    #--------------------------------------------------------------------------

    validates :event_unit, :presence => true
    validates :resource, :presence => true
    # validates :quantity

    # TODO: (2)
    # 1) validate quantity assigned is <= available quantity of the 'resource'
    # OR
    # 2) allow overallocation and provide detection of additional requirements

    #--------------------------------------------------------------------------

    def to_s
      ((name.nil? || name.empty?) ? '' : "#{event.name} - ") + "#{event_unit} - #{resource} - #{quantity}"
    end

    #--------------------------------------------------------------------------

    private

  end
end
