class CreateEvents < ActiveRecord::Migration[5.2]
  def change
    create_table :resource_planner_events do |t|
      t.references :event_owner, :polymorphic => true, :null => true, :index => { :name => :index_resource_planner_events_on_event_owner }

      t.references :parent_event, :default => nil
      t.references :event_type, :polymorphic => true, :default => nil, :index => { :name => :index_resource_planner_events_on_event_type }

      t.string     :name
      t.text       :description

      t.string     :dtstart
      t.datetime   :dtstart_datetime
      t.string     :dtstart_timezone

      t.string     :dtend
      t.datetime   :dtend_datetime
      t.string     :dtend_timezone

      t.string     :duration

      t.string     :day_of_week
      t.string     :day_of_month

      t.string     :rrule
      t.string     :until
      t.string     :count
      t.string     :interval
      t.string     :bysecond
      t.string     :byminute
      t.string     :byhour
      t.string     :byday
      t.string     :bymonthday
      t.string     :byyearday
      t.string     :byweekno
      t.string     :bymonth
      t.string     :bysetpos
      t.string     :wkst
      t.string     :freq

      t.string     :bymonthday_day

      t.text       :ical_expression

      t.timestamps :null => false
    end
  end
end
